#include <bits/stdc++.h>
using namespace std;

const long long mod = 1e9+7;
int n, m, b;
int c [20], ab [20][2];
bool used [20];
struct condition{
    int i, mult, k;
};
vector <condition> adj [20][2];

long long ans = 1;
bool dfs (int i, int j, int val){
    if (ab [i][j] != -1) return ab [i][j] == val;
    ab [i][j] = val;
    used [i] = 1;
    for (auto c : adj [i][j]){
        bool flag = dfs (c.i, 1 - j, (c.k - val) * c.mult);
        if (!flag) return 0;
    }
    return 1;
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> m >> b;
    for (int i = n - 1; i >= 0; i --) cin >> c [i];
    if (c [n - 1] < 2){
        cout << "0\n";
        return 0;
    }
    while (m --){
        int i, j, k;
        char s;
        cin >> i >> s >> j >> k;
        if (s == '+'){
            adj [i][0].push_back ({j, 1, k});
            adj [j][1].push_back ({i, 1, k});
        }
        else{
            adj [i][0].push_back ({j, -1, k});
            adj [j][1].push_back ({i, -1, -k});
        }
    }
    for (int i = 0; i < n; i ++){
        adj [i][0].push_back ({i, 1, c [i]});
        adj [i][1].push_back ({i, 1, c [i]});
    }
    for (int i = 0; i < n; i ++){
        if (used [i]) continue;
        long long cnt = 0;
        for (int j = (i == n - 1 ? 1 : 0); j < (i == n - 1 ? b - 1 : b); j ++){
            for (int h = 0; h < n; h ++) ab [h][0] = ab [h][1] = -1;
            if (dfs (i, 0, j)) cnt ++;
        }
        ans = (ans * cnt) % mod;
    }
    cout << ans % mod << '\n';

}
