#include<bits/stdc++.h>
using namespace std;

const int nmax=1e6+42;
int n,inp[nmax];

int fenwick[nmax];

void init()
{
    for(int i=1;i<=n;i++)fenwick[i]=0;
}
void update(int pos,int val)
{
    while(pos<=n)
    {
        fenwick[pos]+=val;

        pos=pos+(pos&(-pos));
    }
}

int query(int pos)
{
    int ret=0;

    while(pos)
    {
        ret+=fenwick[pos];
        pos=pos-(pos&(-pos));
    }
    return ret;
}
long long inv()
{
    init();

    long long ret=0;

    for(int i=n;i>=1;i--)
    {
        ret+=query(inp[i]);
        update(inp[i],1);
    }

    return ret;
}

int sum(int l,int r)
{
    return query(r)-query(l-1);
}
int main()
{
    scanf("%i",&n);
    for(int i=1;i<=n;i++)scanf("%i",&inp[i]);

    long long was=inv();

    //cout<<"was= "<<was<<endl;

    long long outp=was;

    int mx=0;

    for(int i=1;i<=n;i++)
        if(mx<inp[i])
        {
            mx=inp[i];

            init();

            for(int j=i+1;j<=n;j++)
                if(inp[i]>inp[j])
                {
                    outp=min(outp,was-2*sum(inp[j],inp[i]));

                    //cout<<i<<" "<<j<<" -> "<<was-2*sum(inp[j],inp[i])<<endl;

                    update(inp[j],1);
                }
        }

    printf("%lld\n",outp);

    return 0;
}
