#include <bits/stdc++.h>
#pragma GCC optimize("O3")

using namespace std;
typedef long long ll;
template<class T> void check_min(T &a, const T b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T b){ a = (a > b) ? a : b; }
int get_int();
#define all(x) (x).begin(), (x).end()

const int N = 1e6 + 3;

int n, a[N];

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    n = get_int();
    for(int i = 1; i <= n; ++i)
        a[i] = get_int();

    bool ok = true;
    for(int i = 1; i <= n; ++i)
        if(a[i] != i)
            ok = false;

    if(ok){
        cout << "0\n";
        return 0;
    }

    ll inv = 0;
    for(int l = 1; l <= n; ++l)
        for(int r = l + 1; r <= n; ++r)
            inv += a[l] > a[r];

    ll ans = 0;
    int prev_best_idx = 1;
    for(int l = 1; l <= n; ++l){
        int best_idx = max(prev_best_idx, l + 1);
        ll best = 0;
        for(int r = best_idx; r <= n; ++r){
            if(a[l] < a[r]) continue;
            ll curr = 0;
            for(int i = l + 1; i < r; ++i)
                if(a[r] < a[i] && a[i] < a[l])
                    curr -= 2;
            if(curr < best){
                best = curr;
                best_idx = r;
            }
        }
        check_min(ans, best);
        prev_best_idx = best_idx;
    }
    ans += inv;

    cout << ans << "\n";
}

int ptr = N - 1;
char buff[N];

void next_char(){ if(++ptr == N - 1) fread(buff, 1, N, stdin), ptr = 0; }

int get_int(){
    //remove to pass TL
    int x;
    cin >> x;
    return x;

    int ret = 0;
    for(; buff[ptr] < '0' || '9' < buff[ptr]; next_char());
    for(; '0' <= buff[ptr] && buff[ptr] <= '9'; next_char())
        ret = 10 * ret + buff[ptr] - '0';
    return ret;
}
