#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
template<class T> void check_min(T &a, const T b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T b){ a = (a > b) ? a : b; }
int get_int();
#define all(x) (x).begin(), (x).end()

const int N = 36 + 3;
const int M = 70 + 3;
const int B = 30 + 3;
const int MOD = 1e9 + 7;

int n, m, b;
vector<array<int, 3>> adj[N];
array<int, 3> e_num[M];
char e_c[M];
int vis[N], v[N], c[N];
ll sum_ans = 0;

void dfs_mark(int u, int col){
    vis[u] = col;
    for(auto [to, s, add]: adj[u]){
        if(vis[to] == col) continue;
        dfs_mark(to, col);
    }
}

bool dfs(int u, int val, int col){
    if(val < 0 || val >= b) return false;
    if(val == 0 && n != 1 && (u == n - 1 || u == 2 * n - 1)) return false;
    vis[u] = col;
    v[u] = val;
    for(auto [to, s, add]: adj[u]){
        if(vis[to] == col){
            if(add){
                if(v[u] + v[to] != s) return false;
            }
            else{
                if(u < to){
                    if(v[u] - v[to] != s) return false;
                }
                else{
                    if(v[to] - v[u] != s) return false;
                }
            }
            continue;
        }

        if(add){
            if(!dfs(to, s - v[u], col)) return false;
            continue;
        }
        if(u < to){
            if(!dfs(to, v[u] - s, col)) return false;
            continue;
        }
        if(!dfs(to, v[u] + s, col)) return false;
    }
    return true;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m >> b;
    for(int i = n - 1; i >= 0; --i)
        cin >> c[i];

    for(int i2 = 0; i2 < m; ++i2){
        cin >> e_num[i2][0] >> e_c[i2] >> e_num[i2][1] >> e_num[i2][2];
    }

    for(int mask = 0; mask < (1 << (n - 1)); ++mask){
        for(int i = 0; i < 2 * n; ++i)
            adj[i].clear();

        for(int i = n - 1; i >= 0; --i){
            int sum = c[i] + (((mask >> i) & 1) ? b : 0);
            if(i) sum -= ((mask >> (i - 1)) & 1);
            adj[i].push_back({n + i, sum, true});
            adj[n + i].push_back({i, sum, true});
        }

        for(int i2 = 0; i2 < m; ++i2){
            adj[e_num[i2][0]].push_back({n + e_num[i2][1], e_num[i2][2], (e_c[i2] == '+')});
            adj[n + e_num[i2][1]].push_back({e_num[i2][0], e_num[i2][2], (e_c[i2] == '+')});
        }

        for(int i = 0; i < 2 * n; ++i)
            vis[i] = -1;

        ll ans = 1;
        for(int i = 0; i < 2 * n; ++i)
        if(vis[i] == -1){
            ll curr = 0;
            for(int j = 0; j < b; ++j){
                bool ok = dfs(i, j, j);
                curr += ok;
            }

            dfs_mark(i, b - 1);
            ans = ans * curr % MOD;
            //cout << curr << " - " << i << endl;
        }
        sum_ans += ans;
        if(sum_ans >= MOD) sum_ans -= MOD;
    }

    cout << sum_ans << "\n";
}

