#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e6 + 3;

int n;
int a[maxn];
void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> a[i];
}

int tr[maxn];
void update(int pos, int val)
{
    for (; pos <= n; pos += pos & -pos)
        tr[pos] += val;
}

int get_prefix(int pos)
{
    int ans = 0;
    for (; pos >= 1; pos -= pos & -pos)
        ans += tr[pos];

    return ans;
}

long long count_inversions()
{
    for (int i = 1; i <= n; i++)
        tr[i] = 0;

    long long ans = 0;
    for (int i = n; i >= 1; i--)
    {
        ans += get_prefix(a[i]);
        update(a[i], 1);
    }

    return ans;
}

void solve()
{
    long long ans = count_inversions();
    for (int i = 1; i <= n; i++)
        for (int j = i + 1; j <= n; j++)
    {
        swap(a[i], a[j]);
        ans = min(ans, 1 + count_inversions());

        swap(a[i], a[j]);
    }

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
