#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e4 + 3;

int n;
int a[maxn];
void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> a[i];
}

int tr[maxn];
void update(int pos, int val)
{
    for (; pos <= n; pos += pos & -pos)
        tr[pos] += val;
}

int get_prefix(int pos)
{
    int ans = 0;
    for (; pos >= 1; pos -= pos & -pos)
        ans += tr[pos];

    return ans;
}

long long count_inversions()
{
    for (int i = 1; i <= n; i++)
        tr[i] = 0;

    long long ans = 0;
    for (int i = n; i >= 1; i--)
    {
        ans += get_prefix(a[i]);
        update(a[i], 1);
    }

    return ans;
}

int segtr[maxn * 4];
void merge(int v)
{
    segtr[v] = max(segtr[v * 2], segtr[v * 2 + 1]);
}

void update_tr(int v, int l, int r, int pos, int val)
{
    if (l == r)
    {
        segtr[v] = val;
        return;
    }

    int mid = (l + r) / 2;
    if (pos <= mid)
        update_tr(v * 2, l, mid, pos, val);

    else
        update_tr(v * 2 + 1, mid + 1, r, pos, val);

    merge(v);
}

int get_tr(int v, int l, int r, int ll, int rr)
{
    if (l > rr || r < ll)
        return 0;

    if (l >= ll && r <= rr)
    return segtr[v];

    int mid = (l + r) / 2;
    return max(get_tr(v * 2, l, mid, ll, rr), get_tr(v * 2 + 1, mid + 1, r, ll, rr));
}

short f[maxn][maxn];
int nxt[maxn], opt[maxn];
void solve()
{
    for (int i = n; i >= 1; i--)
    {
        f[i][i] = 0;
        for (int j = i-1; j >= 1; j--)
        {
            f[i][j] = f[i][j+1];
            if (a[j] < a[i])
                f[i][j]++;
        }
    }

    for (int i = 1; i <= n; i++)
    {
        nxt[i] = n+1;
        for (int j = i + 1; j <= n; j++)
            if (a[j] > a[i])
        {
            nxt[i] = j;
            break;
        }
    }

    opt[n+1] = n+1;

    long long ans = count_inversions();
    int maxf = 0;
    for (int i = 1; i <= n; i++)
    {
        int bad = 0, curr = -1, idx = i;
        for (int j = i + 1; j <= n; j++)
        {
            if (a[j] > a[i])
            {
                bad++;
                continue;
            }

            if (j - i + 1 - bad - (int)f[j][i] > curr)
            {
                curr = j - i + 1 - bad - (int)f[j][i];
                idx = j;
            }

            maxf = max(maxf, j - i + 1 - bad - (int)f[j][i]);
        }

        opt[i] = idx;
    }

    for (int i = 1; i <= n; i++)
        if (opt[i] >= opt[nxt[i]])
    {
        cout << "shit" << endl;
    }

    cout << min(ans, ans + 4 - 2 * maxf) << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
