#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int mod = 1e9 + 7;

int add(int a, int b)
{
    a += b;
    if (a >= mod)
        a -= mod;

    return a;
}

struct cond
{
    int to, eq;
    char sign;

    cond() {}
    cond(int to, int eq, char sign)
    {
        this->to = to;
        this->eq = eq;
        this->sign = sign;
    }
};

const int maxn = 10003;

int n, m, b;
int ce[maxn];
vector <cond> adj[maxn * 2];

void read()
{
    cin >> n >> m >> b;
    for (int i = 1; i <= n; i++)
        cin >> ce[i];

    for (int i = 1; i <= m; i++)
    {
        int x, y, eq;
        char sign;
        cin >> x >> sign >> y >> eq;
        x++;
        y++;

        adj[x].push_back(cond(n + y, eq, sign));

        if (sign == '+')
            adj[n + y].push_back(cond(x, eq, sign));

        else
            adj[n + y].push_back(cond(x, -eq, sign));
    }
}

set <int> vals;
bool can = true;
bool used[maxn * 2];
pair <int, int> c[maxn * 2];
vector <int> comp;

void dfs(int ver)
{
    comp.push_back(ver);
    used[ver] = true;
    for (auto i: adj[ver])
    {
        if (!used[i.to])
        {
            if (i.sign == '+')
            {
                c[i.to].first = -c[ver].first;
                c[i.to].second = i.eq - c[ver].second;
            }

            else
            {
                c[i.to].first = c[ver].first;
                c[i.to].second = c[ver].second - i.eq;
            }

            dfs(i.to);
        }

        else
        {
            if (i.sign == '+')
            {
                if (c[ver].first + c[i.to].first == 0)
                {
                    if (c[ver].second + c[i.to].second != i.eq)
                        can = false;
                }

                else
                {
                    assert(c[ver].first + c[i.to].first != 0);
                    int sum = i.eq - c[ver].second - c[i.to].second;
                    if (sum % (c[ver].first + c[i.to].first) != 0)
                        can = false;

                    else
                        vals.insert(sum / (c[ver].first + c[i.to].first));
                }
            }

            else
            {
                if (c[ver].first - c[i.to].first != 0)
                {
                    if (c[ver].second - c[i.to].second != i.eq)
                        can = false;
                }

                else
                {
                    assert(c[ver].first - c[i.to].first != 0);
                    int sum = i.eq + c[i.to].second - c[ver].second;
                    if (sum % (c[ver].first - c[i.to].first) != 0)
                        can = false;

                    else
                        vals.insert(sum / (c[ver].first - c[i.to].first));
                }
            }
        }
    }
}

void solve()
{
    for (int i = 1; i <= n; i++)
    {
        adj[i].push_back(cond(n + i, b - 1, '+'));
        adj[n + i].push_back(cond(i, b - 1, '+'));
    }

    int ans = 1;
    for (int i = 1; i <= 2 * n && can; i++)
        if (!used[i])
        {
            c[i] = {1, 0};
            vals.clear();
            comp.clear();

            dfs(i);

            if (vals.size() > 1 || !can)
            {
                ans = 0;
                break;
            }

            if (!vals.empty())
            {
                int x = *vals.begin();
                for (auto j: comp)
                {
                    int curr = c[j].first * x + c[j].second;
                    if (curr < 0 || curr >= b || ((j == 1 || j == n + 1) && curr == 0))
                    {
                        can = false;
                        ans = 0;
                        break;
                    }
                }
            }

            else
            {
                int cnt = 0;
                for (int val = 0; val < b; val++)
                {
                    bool curr_can = true;
                    for (auto j: comp)
                    {
                        long long curr = c[j].first * val + c[j].second;
                        if (curr < 0 || curr >= b || ((j == 1 || j == n + 1) && curr == 0))
                        {
                            curr_can = false;
                            break;
                        }
                    }

                    if (curr_can)
                        cnt++;
                }

                ans = 1ll * ans * cnt % mod;
            }
        }

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}

/*
4 0 10
9 9 9 9
*/
