#include <iostream>

using namespace std;

const int MAXN = 2e6 + 5;
const int inf = 1e9 + 5;

int n;
int a[MAXN];

void solveTestcase()
{
    int K;
    int rw, rg;

    cin >> n >> K;
    cin >> rw >> rg;
    for(int i = 0;i<n;i++) cin >> a[i];
    if(rw<rg) swap(rw, rg);

    bool fail = false;
    int lastW = -inf, lastG = -inf;

    for(int i = 0;i<n;i++)
    {
        if(a[i]-lastW>=rw) lastW = a[i];
        else if(a[i]-lastG>=rg) lastG = a[i];
        else
        {
            fail = true;
            break;
        }
    }

    cout << (fail^1) << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int T;
    cin >> T;

    while(T--) solveTestcase();
}
