#include <iostream>
#include <vector>
#include <deque>

using namespace std;

const int MAXN = 2e6 + 5;
const int inf = 1e9 + 5;

int n;
int a[MAXN];

int col[MAXN];
void solveTestcase()
{
    int K;
    int rw, rg;

    cin >> n >> K;

    vector <int> r;
    for(int i = 0;i<K;i++)
    {
        int x;
        cin >> x;
        r.push_back(x);
    }

    for(int i = 0;i<n;i++) cin >> a[i];

    int lastVal[3] = {-inf, -inf, -inf};
    for(int i = 0;i<n;i++) col[i] = i%K;

    bool fail = false;
    for(int i = 0;i<n;i++)
    {
        if(a[i]-lastVal[col[i]]<r[col[i]])
        {
            fail = true;
            break;
        }

        lastVal[col[i]] = a[i];
    }

    cout << (fail^1) << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int T;
    cin >> T;

    while(T--) solveTestcase();
}
/*
1
3 2
1000 2
1 2 100
*/
