#include <iostream>
using namespace std;

const int MAXN = 500005;

int n, k;
int pos[MAXN];

bool Try(int x, int y, int z)
{
    int prv1 = -x, prv2 = -y, prv3 = -z;
    for (int i = 1; i <= n; ++ i)
    {
        if (i % 3 == 1)
        {
            if (pos[i] - prv1 < x) return 0;
            else prv1 = pos[i];
        }
        if (i % 3 == 2)
        {
            if (pos[i] - prv2 < x) return 0;
            else prv2 = pos[i];
        }
        if (i % 3 == 0)
        {
            if (pos[i] - prv3 < x) return 0;
            else prv3 = pos[i];
        }
    }

    return 1;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t;
    cin >> t;

    while (t--)
    {
        int rw, rg, rb;
        cin >> n >> k;
        cin >> rw;
        if (k >= 2) cin >> rg;
        if (k >= 3) cin >> rb;

        if (k == 1)
        {
            int prv = -rb;
            bool fl = true;
            for (int i = 1; i <= n; ++ i)
            {
                int tek;
                cin >> tek;
                if (tek - prv < rb) fl = false;
                prv = tek;
            }
            if (fl) cout << 1 << endl;
            else cout << 0 << endl;
        }
        if (k == 3 and rw == rg and rg == rb)
        {
            for (int i = 1; i <= n; ++ i)
            {
                cin >> pos[i];
            }

            if (Try(rw, rg, rb)) cout << 1 << endl;
            else if (Try(rw, rb, rg)) cout << 1 << endl;
            else if (Try(rg, rb, rg)) cout << 1 << endl;
            else if (Try(rg, rg, rb)) cout << 1 << endl;
            else if (Try(rb, rg, rw)) cout << 1 << endl;
            else if (Try(rb, rw, rg)) cout << 1 << endl;
            else cout << 0 << endl;
        }

    }
}
