#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const int MAXN = 500000;

int t, n, k;
int r[3];
int coords[MAXN];

struct mag
{
    int last[3];
};

bool ans;
vector<mag> v[MAXN][3];

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> t;
    for(int z = 0; z < t; z++){
        ans = true;
        cin >> n >> k;
        for(int i = 0; i < k; i++){
            cin >> r[i];
        }
        //sort(r, r+k);
        for(int i = 0; i < n; i++){
            cin >> coords[i];
        }

        v[0][0].push_back({0, -1, -1});
        if(k > 1) v[0][1].push_back({-1, 0, -1});
        if(k > 2) v[0][2].push_back({-1, -1, 0});

        for(int i = 1; i < n; i++){
            for(int j = 0; j < k; j++){
                if(coords[i] - coords[i-1] >= r[j]){
                    for(int a = 0; a < v[i-1][j].size(); a++){
                        v[i][j].push_back(v[i-1][j][a]);
                        v[i][j].back().last[j] = i;
                    }
                }
                for(int a = 0; a < k; a++){
                    if(a != j){
                        for(int b = 0; b < v[i-1][a].size(); b++){
                            if(v[i-1][a][b].last[j] != -1 && coords[i] - coords[v[i-1][a][b].last[j]] < r[j]){
                                continue;
                            }
                            /*if(v[i][j].empty()){
                                v[i][j].push_back(v[i-1][a][b]);
                                v[i][j][v[i][j].size()-1].last[j] = i;
                            }*/
                            bool fl = false;
                            for(int c = 0; c < v[i][j].size(); c++){
                                if(j == 0){
                                    if(v[i][j][c].last[1] <= v[i][j][c].last[2] && v[i-1][a][b].last[1] <= v[i-1][a][b].last[2]){
                                        fl = true;
                                        if((v[i][j][c].last[1] >= v[i-1][a][b].last[1] && v[i][j][c].last[2] > v[i-1][a][b].last[2]) || (v[i][j][c].last[2] >= v[i-1][a][b].last[2] && v[i][j][c].last[1] > v[i-1][a][b].last[1])){
                                            v[i][j][c].last[1] = v[i-1][a][b].last[1];
                                            v[i][j][c].last[2] = v[i-1][a][b].last[2];
                                        }
                                        continue;
                                    }
                                    if(v[i][j][c].last[1] >= v[i][j][c].last[2] && v[i-1][a][b].last[1] >= v[i-1][a][b].last[2]){
                                        fl = true;
                                        if((v[i][j][c].last[1] >= v[i-1][a][b].last[1] && v[i][j][c].last[2] > v[i-1][a][b].last[2]) || (v[i][j][c].last[2] >= v[i-1][a][b].last[2] && v[i][j][c].last[1] > v[i-1][a][b].last[1])){
                                            v[i][j][c].last[1] = v[i-1][a][b].last[1];
                                            v[i][j][c].last[2] = v[i-1][a][b].last[2];
                                        }
                                        continue;
                                    }
                                }
                                if(j == 1){
                                    if(v[i][j][c].last[0] <= v[i][j][c].last[2] && v[i-1][a][b].last[0] <= v[i-1][a][b].last[2]){
                                        fl = true;
                                        if((v[i][j][c].last[0] >= v[i-1][a][b].last[0] && v[i][j][c].last[2] > v[i-1][a][b].last[2]) || (v[i][j][c].last[2] >= v[i-1][a][b].last[2] && v[i][j][c].last[0] > v[i-1][a][b].last[0])){
                                        v[i][j][c].last[0] = v[i-1][a][b].last[0];
                                        v[i][j][c].last[2] = v[i-1][a][b].last[2];
                                        }
                                        continue;
                                    }
                                    if(v[i][j][c].last[0] >= v[i][j][c].last[2] && v[i-1][a][b].last[0] >= v[i-1][a][b].last[2]){
                                        fl = true;
                                        if((v[i][j][c].last[0] >= v[i-1][a][b].last[0] && v[i][j][c].last[2] > v[i-1][a][b].last[2]) || (v[i][j][c].last[2] >= v[i-1][a][b].last[2] && v[i][j][c].last[0] > v[i-1][a][b].last[0])){
                                        v[i][j][c].last[0] = v[i-1][a][b].last[0];
                                        v[i][j][c].last[2] = v[i-1][a][b].last[2];
                                        }
                                        continue;
                                    }
                                }
                                if(j == 2){
                                    if(v[i][j][c].last[1] <= v[i][j][c].last[0] && v[i-1][a][b].last[1] <= v[i-1][a][b].last[0]){
                                        fl = true;
                                        if((v[i][j][c].last[1] >= v[i-1][a][b].last[1] && v[i][j][c].last[0] > v[i-1][a][b].last[0]) || (v[i][j][c].last[0] >= v[i-1][a][b].last[0] && v[i][j][c].last[1] > v[i-1][a][b].last[1])){
                                        v[i][j][c].last[1] = v[i-1][a][b].last[1];
                                        v[i][j][c].last[0] = v[i-1][a][b].last[0];
                                        }
                                        continue;
                                    }
                                    if(v[i][j][c].last[1] >= v[i][j][c].last[0] && v[i-1][a][b].last[1] >= v[i-1][a][b].last[0] && ){
                                        fl = true;
                                        if((v[i][j][c].last[1] >= v[i-1][a][b].last[1] && v[i][j][c].last[0] > v[i-1][a][b].last[0]) || (v[i][j][c].last[0] >= v[i-1][a][b].last[0] && v[i][j][c].last[1] > v[i-1][a][b].last[1])){
                                        v[i][j][c].last[1] = v[i-1][a][b].last[1];
                                        v[i][j][c].last[0] = v[i-1][a][b].last[0];

}                                        continue;
                                    }
                                }
                                //cout << "kowabunga it is" << c << endl;
                            }
                            if(!fl){
                                v[i][j].push_back(v[i-1][a][b]);
                                v[i][j].back().last[j] = i;
                            }
                        }
                    }
                }
            }
            if(v[i][0].empty() && v[i][1].empty() && v[i][2].empty()){
                ans = false;
                break;
            }
        }

        cout << ans << endl;
        for(int i = 0; i < n; i++){
            v[i][0].clear();
            v[i][1].clear();
            v[i][2].clear();
        }
    }

return 0;
}

