#include <bits/stdc++.h>
using namespace std;

const int inf = 1e9;
int n, a [1000006], pos [1000006];
int fenwick [1000006];
void upd (int x){
    while (x <= n){
        fenwick [x] ++;
        x += x & -x;
    }
}
int query (int x){
    int ans = 0;
    while (x > 0){
        ans += fenwick [x];
        x -= x & -x;
    }
    return ans;
}
long long inv;
int x;
int lessThan [10004][10004];

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;
    for (int i = 1; i <= n; i ++){
        cin >> a [i];
        pos [a [i]] = i;
    }
    for (int i = n; i > 0; i --){
        inv += query (a [i]);
        upd (a [i]);
    }
    for (int i = 1; i <= n; i ++){
        for (int j = 1; j <= n; j ++) lessThan [i][j] = lessThan [i - 1][j];
        for (int j = a [i] + 1; j <= n; j ++) lessThan [i][j] ++;
    }
    for (int i = 1; i <= n; i ++){
        for (int j = i + 1; j <= n; j ++){
            if (a [i] > a [j]) x = max (x, lessThan [j - 1][a [i]] - lessThan [i][a [i]] - lessThan [j - 1][a [j]] + lessThan [i][a [j]]);
        }
    }
    cout << inv - 2 * x << '\n';

}
