# include <bits/stdc++.h>
using namespace std;
const int maxn = 2e6+5;
int p[maxn];

int fen[maxn];
void update(int x, int p)
{
    for(int idx=x; idx<maxn; idx+=idx&(-idx))
    {
        fen[idx]+=p;
    }
}
int query(int x)
{
    int sum = 0;
    for(int idx = x; idx>0; idx-=idx&(-idx))
    {
        sum+=fen[idx];
    }
    return sum;
}

int main()
{
    ios_base::sync_with_stdio();
    cin.tie(NULL);
    int n;
    int i,j;
    cin>>n;
    int ans = 0;
    for(i=1; i<=n; i++)
    {
        cin>>p[i];
       // cout<<i<<" "<<query(p[i])<<endl;
        ans+=(i-query(p[i])-1);
        update(p[i],1);
    }
    memset(fen,0,sizeof(fen));
    int maxs = 0;
    int t;
    for(i=1;i<=n;i++)
    {
        t = 0;
        for(j=i+1;j<=n;j++)
        {
            if(p[j]<p[i]){
            int k= query(p[j]);
            maxs = max(maxs,2*k-2*t);}
            update(p[j],1);
            if(p[j]>p[i])t++;

        }
        for(j=i+1;j<=n;j++)
        {
            update(p[j],-1);
        }
    }
    cout<<ans-maxs<<endl;

    return 0;
}
