#include<bits/stdc++.h>
using namespace std;

const int nmax=1000,mod=1e9+7;
int n,m,base,c[nmax];

int LHS[nmax];

char OP[nmax];

int RHS[nmax],K[nmax];

int a[nmax],b[nmax];
int outp;

int pointer;

void add_line(int i,char op,int j,int k)
{
    pointer++;
    LHS[pointer]=i;
    OP[pointer]=op;
    RHS[pointer]=j;
    K[pointer]=k;
}

vector< int > adj[nmax];

int been[nmax];

pair<int,int> eq[nmax];

pair<int,int> possible;

pair<int,int> common(pair<int,int> a,pair<int,int> b)
{
    return {max(a.first,b.first),min(a.second,b.second)};
}
void update(pair<int,int> eq_now,int l,int r)
{
    int p=eq_now.first;
    int q=eq_now.second;

    //cout<<"l= "<<l<<" p= "<<p<<" q= "<<q<<" r= "<<r<<endl;

    l=l-q;
    r=r-q;

    if(p<0)
    {
        p=-p,l=-l,r=-r;
        swap(l,r);
    }

    possible=common(possible,{l,r});

    //cout<<"solution: "<<l<<" "<<r<<endl;
}
void dfs(int node,pair<int,int> eq_now)
{
    //cout<<"dfs "<<node<<" "<<eq_now.first<<" "<<eq_now.second<<" possible: "<<possible.first<<" "<<possible.second<<endl;

    if(possible.first>possible.second)return;

    if(eq[node].first)
    {
        int p=eq[node].first-eq_now.first;
        int q=eq_now.second-eq[node].second;

        if(p==0)
        {
            if(q!=0)possible={0,-1};
            return;
        }
        else
        {
            if(p<0)p=-p,q=-q;

            if(q%p)possible={0,-1};
            else possible=common(possible,{q/p,q/p});
        }

        return;
    }

    eq[node]=eq_now;
    been[node]=1;

    if(node%n==n-1)update(eq_now,1,base-1);
    else update(eq_now,0,base-1);

    for(auto id:adj[node])
    {
        if(node<n)
        {
            if(OP[id]=='+')
            {
                dfs(RHS[id]+n,{-eq_now.first,K[id]-eq_now.second});
            }
            else//OP[id]='-'
            {
                dfs(RHS[id]+n,{eq_now.first,eq_now.second-K[id]});
            }
        }
        else//node>n => b[id-n]
        {
            if(OP[id]=='+')
            {
                dfs(LHS[id],{-eq_now.first,K[id]-eq_now.second});
            }
            else
            {
                dfs(LHS[id],{eq_now.first,eq_now.second+K[id]});
            }
        }
    }
}
void eval()
{
    /*
    cout<<"eval: ";
    for(int i=1;i<=pointer;i++)
        cout<<LHS[i]<<" "<<OP[i]<<" "<<RHS[i]<<" "<<K[i]<<endl;
    */

    for(int i=0;i<2*n;i++)
    {
        eq[i]={0,0};

        adj[i]={};
        been[i]=0;
    }

    for(int i=1;i<=pointer;i++)
    {
        adj[LHS[i]].push_back(i);
        adj[RHS[i]+n].push_back(i);
    }

    long long ret=1;
    for(int i=0;i<2*n;i++)
        if(been[i]==0)
        {
            possible={0,base-1};

            dfs(i,{1,0});

            //cout<<"---"<<endl;

            if(possible.first>possible.second)return;

            ret=ret*(possible.second-possible.first+1)%mod;
        }

    outp=(outp+ret)%mod;
}

void go(int pos,int carry)
{
    if(pos==n)
    {
        eval();
        return;
    }

    int border=2;

    if(pos==n-1)border=1;

    for(int carry_now=0;carry_now<border;carry_now++)
    {
        if(carry==0&&carry_now==0)add_line(pos,'+',pos,c[pos]);
        else if(carry==0&&carry_now==1)
        {
            if(c[pos]==base-1)continue;

            add_line(pos,'+',pos,c[pos]+base);
        }
        else if(carry==1&&carry_now==0)
        {
            if(c[pos]==0)continue;

            add_line(pos,'+',pos,c[pos]-1);
        }
        else if(carry==1&&carry_now==1)
        {
            add_line(pos,'+',pos,c[pos]-1+base);
        }

        go(pos+1,carry_now);

        pointer--;
    }

}
int main()
{
    cin>>n>>m>>base;
    for(int i=n-1;i>=0;i--)cin>>c[i];

    for(int i=1;i<=m;i++)
    {
        cin>>LHS[i]>>OP[i]>>RHS[i]>>K[i];
    }

    pointer=m;

    go(0,0);

    printf("%i\n",outp);

    return 0;
}
