#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
template<class T> void check_min(T &a, const T b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T b){ a = (a > b) ? a : b; }
int get_int();
#define all(x) (x).begin(), (x).end()

const int N = 5e5 + 3;
const int INF = 1e9;

int n, k;
int r[3], p[N];
bool vis[N];

bool solve(int idx){
    if(idx == k){
        for(int i = 0; i < n; ++i)
            if(!vis[i])
                return false;
        return true;
    }

    int prev = -INF;
    vector<int> v;
    for(int i = 0; i < n; ++i){
        if(vis[i]) continue;
        if(prev + r[idx] <= p[i]){
            vis[i] = true;
            v.push_back(i);
            prev = p[i];
        }
    }

    if(solve(idx + 1)) return true;

    for(int x: v)
        vis[x] = false;

    return false;
}

void solve(){
    n = get_int(), k = get_int();
    for(int i = 0; i < k; ++i)
        r[i] = get_int();
    for(int i = 0; i < n; ++i)
        p[i] = get_int();

    sort(r, r + k);
    cout << solve(0) << "\n";
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int t;
    t = get_int();
    while(t--) solve();
}

int ptr = N - 1;
char buff[N];

void next_char(){ if(++ptr == N - 1) fread(buff, 1, N, stdin), ptr = 0; }

int get_int(){
    int x;
    cin >> x;
    return x;

    int ret = 0;
    for(; buff[ptr] < '0' || '9' < buff[ptr]; next_char());
    for(; '0' <= buff[ptr] && buff[ptr] <= '9'; next_char())
        ret = 10 * ret + buff[ptr] - '0';
    return ret;
}


