#include <bits/stdc++.h>
#pragma GCC optimize("O3")

using namespace std;
typedef long long ll;
template<class T> void check_min(T &a, const T b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T b){ a = (a > b) ? a : b; }
int get_int();
#define all(x) (x).begin(), (x).end()

const int N = 1e6 + 3;

int n, a[N];
ll val[N];
int opt[N];
vector<int> v;
ll ans = 0;

void dnc(int l, int r, int sl, int sr){
    if(l > r) return;

    int mid = (l + r) >> 1;
    int idx = v[mid];
    opt[mid] = -1;
    val[mid] = 1;
    for(int i = max(idx + 1, sl); i <= sr; ++i){
        if(a[i] > a[idx]) continue;
        ll curr = 0;
        for(int j = idx + 1; j < i; ++j)
            if(a[idx] > a[j] && a[j] > a[i])
                curr -= 2;
        if(curr < val[mid]){
            val[mid] = curr;
            opt[mid] = i;
        }
    }
    check_min(ans, val[mid]);

    dnc(l, mid - 1, sl, sr);
    dnc(mid + 1, r, sl, sr);
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    n = get_int();
    for(int i = 1; i <= n; ++i)
        a[i] = get_int();

    bool ok = true;
    for(int i = 1; i <= n; ++i)
        if(a[i] != i)
            ok = false;

    if(ok){
        cout << "0\n";
        return 0;
    }

    ll inv = 0;
    for(int l = 1; l <= n; ++l)
        for(int r = l + 1; r <= n; ++r)
            inv += a[l] > a[r];

    int mn = n;
    for(int i = n; i >= 1; --i){
        if(a[i] > mn) v.push_back(i);
        else mn = a[i];
    }
    reverse(v.begin(), v.end());

    dnc(0, (int)v.size() - 1, 1, n);

    cout << ans + inv << "\n";
}

int ptr = N - 1;
char buff[N];

void next_char(){ if(++ptr == N - 1) fread(buff, 1, N, stdin), ptr = 0; }

int get_int(){
    //remove to pass TL
    int x;
    cin >> x;
    return x;

    int ret = 0;
    for(; buff[ptr] < '0' || '9' < buff[ptr]; next_char());
    for(; '0' <= buff[ptr] && buff[ptr] <= '9'; next_char())
        ret = 10 * ret + buff[ptr] - '0';
    return ret;
}

