#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
template<class T> void check_min(T &a, const T b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T b){ a = (a > b) ? a : b; }
int get_int();
#define all(x) (x).begin(), (x).end()

const int N = 100 + 3;
const int B = 30 + 3;
const int MOD = 1e9 + 7;

int n, m, b;
vector<array<int, 3>> adj[N];
int vis[N], v[N];

bool dfs(int u, int val, int col){
    if(val < 0 || val >= b) return false;
    if(val == 0 && (u == n - 1 || u == 2 * n - 1)) return false;
    vis[u] = col;
    v[u] = val;
    for(auto [to, s, add]: adj[u]){
        if(vis[to] == col){
            if(add){
                if(v[u] + v[to] != s) return false;
            }
            else{
                if(u < to){
                    if(v[u] - v[to] != s) return false;
                }
                else{
                    if(v[to] - v[u] != s) return false;
                }
            }
            continue;
        }

        if(add){
            if(!dfs(to, s - v[u], col)) return false;
            continue;
        }
        if(u < val){
            if(!dfs(to, v[u] - s, col)) return false;
            continue;
        }
        if(!dfs(to, v[u] + s, col)) return false;
    }
    return true;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m >> b;
    for(int i = n - 1; i >= 0; --i){
        int c;
        cin >> c;
        assert(c == b - 1);
        adj[i].push_back({n + i, c, true});
        adj[n + i].push_back({i, c, true});
    }

    for(int i2 = 0; i2 < m; ++i2){
        int i, j, k;
        char c;
        cin >> i >> c >> j >> k;
        adj[i].push_back({n + j, k, (c == '+')});
        adj[n + j].push_back({i, k, (c == '+')});
    }

    for(int i = 0; i < 2 * n; ++i)
        vis[i] = -1;

    ll ans = 1;
    for(int i = 0; i < 2 * n; ++i)
    if(vis[i] == -1){
        ll curr = 0;
        for(int j = 0; j < b; ++j){
            bool ok = dfs(i, j, j);
            curr += ok;
        }
        ans = ans * curr % MOD;
    }

    cout << ans << "\n";
}

