#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
template<class T> void check_min(T &a, const T b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T b){ a = (a > b) ? a : b; }
int get_int();
#define all(x) (x).begin(), (x).end()

const int N = 36 + 3;
const int M = 70 + 3;
const int B = 30 + 3;
const int MOD = 1e9 + 7;

int n, m, b;
vector<array<int, 3>> adj[N];
array<int, 3> e_num[M];
char e_c[M];
int vis[N], v[N], c[N];
bool inv[N];
ll sum_ans = 0;
pair<int, int> range;
vector<int> forbidden;

void dfs_mark(int u, int col){
    vis[u] = col;
    for(auto [to, s, add]: adj[u]){
        if(vis[to] == col) continue;
        dfs_mark(to, col);
    }
}

void dfs(int u, int val, int col, bool invert = false){
    if(!invert){
        check_max(range.first, -val);
        check_min(range.second, b - 1 - val);
        if(n != 1 && (u == n - 1 || u == 2 * n - 1)){
            forbidden.push_back(-val);
        }
    }
    else{
        check_min(range.second, val);
        check_max(range.first, val - (b - 1));
        if(n != 1 && (u == n - 1 || u == 2 * n - 1)){
            forbidden.push_back(val);
        }
    }

    inv[u] = invert;
    vis[u] = col;
    v[u] = val;
    for(auto [to, s, add]: adj[u]){
        if(vis[to] == col){
            if(add){
                if(inv[to] != inv[u]){
                    if(v[to] + v[u] != s){
                        range = {1, 0};
                        return;
                    }
                }
                else{
                    if(!inv[u]){
                        int sol = s - v[u] - v[to];
                        if(sol & 1){
                            range = {1, 0};
                            return;
                        }
                        sol /= 2;
                        if(sol < range.first || range.second < sol){
                            range = {1, 0};
                            return;
                        }
                        range = {sol, sol};
                    }
                    else{
                        int sol = s - v[u] - v[to];
                        if(sol & 1){
                            range = {1, 0};
                            return;
                        }
                        sol /= 2;
                        sol = -sol;
                        if(sol < range.first || range.second < sol){
                            range = {1, 0};
                            return;
                        }
                        range = {sol, sol};
                    }
                }
            }
            else{
                if(u < to){
                    if(inv[u] == inv[to]){
                        if(v[u] - v[to] != s){
                            range = {1, 0};
                            return;
                        }
                    }
                    else{
                        if(!inv[u]){
                            int sol = s + v[to] - v[u];
                            if(sol & 1){
                                range = {1, 0};
                                return;
                            }
                            sol /= 2;
                            if(sol < range.first || range.second < sol){
                                range = {1, 0};
                                return;
                            }
                            range = {sol, sol};
                        }
                        else{
                            int sol = s + v[to] - v[u];
                            if(sol & 1){
                                range = {1, 0};
                                return;
                            }
                            sol /= 2;
                            sol = -sol;
                            if(sol < range.first || range.second < sol){
                                range = {1, 0};
                                return;
                            }
                            range = {sol, sol};
                        }
                    }
                }
                else{
                    if(inv[u] == inv[to]){
                        if(v[to] - v[u] != s){
                            range = {1, 0};
                            return;
                        }
                    }
                    else{
                        if(!inv[to]){
                            int sol = s + v[u] - v[to];
                            if(sol & 1){
                                range = {1, 0};
                                return;
                            }
                            sol /= 2;
                            if(sol < range.first || range.second < sol){
                                range = {1, 0};
                                return;
                            }
                            range = {sol, sol};
                        }
                        else{
                            int sol = s + v[u] - v[to];
                            if(sol & 1){
                                range = {1, 0};
                                return;
                            }
                            sol /= 2;
                            sol = -sol;
                            if(sol < range.first || range.second < sol){
                                range = {1, 0};
                                return;
                            }
                            range = {sol, sol};
                        }
                    }
                }
            }
            continue;
        }

        if(add){
            dfs(to, s - v[u], col, !invert);
            continue;
        }
        if(u < to){
            dfs(to, v[u] - s, col, invert);
            continue;
        }
        dfs(to, v[u] + s, col, invert);
    }
    return;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m >> b;
    for(int i = n - 1; i >= 0; --i)
        cin >> c[i];

    for(int i2 = 0; i2 < m; ++i2){
        cin >> e_num[i2][0] >> e_c[i2] >> e_num[i2][1] >> e_num[i2][2];
    }

    for(int mask = 0; mask < (1 << (n - 1)); ++mask){
        for(int i = 0; i < 2 * n; ++i)
            adj[i].clear();

        for(int i = n - 1; i >= 0; --i){
            int sum = c[i] + (((mask >> i) & 1) ? b : 0);
            if(i) sum -= ((mask >> (i - 1)) & 1);
            adj[i].push_back({n + i, sum, true});
            adj[n + i].push_back({i, sum, true});
        }

        for(int i2 = 0; i2 < m; ++i2){
            adj[e_num[i2][0]].push_back({n + e_num[i2][1], e_num[i2][2], (e_c[i2] == '+')});
            adj[n + e_num[i2][1]].push_back({e_num[i2][0], e_num[i2][2], (e_c[i2] == '+')});
        }

        for(int i = 0; i < 2 * n; ++i)
            vis[i] = -1;

        ll ans = 1;
        for(int i = 0; i < 2 * n; ++i)
        if(vis[i] == -1){
            ll curr = 0;
            forbidden.clear();
            range = {0, b - 1};
            dfs(i, 0, 1);

            if(range.first > range.second){
                ans = 0;
                break;
            }

            sort(forbidden.begin(), forbidden.end());
            forbidden.resize(unique(all(forbidden)) - forbidden.begin());

            int cnt = range.second - range.first + 1;
            for(int x: forbidden)
                if(range.first <= x && x <= range.second)
                    --cnt;

            ans = ans * cnt % MOD;
            //cout << curr << " - " << i << endl;
        }
        sum_ans += ans;
        if(sum_ans >= MOD) sum_ans -= MOD;
    }

    cout << sum_ans << "\n";
}

