#include <bits/stdc++.h>
using namespace std;
//#pragma GCC target("sse4")
//#pragma GCC optimize("Ofast")
#define endl "\n"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) {out << x.first << " " << x.second; return out;}
template<class T, class T2> inline istream &operator >>(istream & in, pair<T, T2> &x) {in >> x.first >> x.second; return in;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}

const ll MAX_N = 1e5 + 10;
ll tree[4 * MAX_N], lazy[4 * MAX_N];
ll arr[MAX_N], n;

void push(int curr, int l, int r) {
    if(lazy[curr] == -1) {return;}
    tree[curr] = (r - l + 1) * lazy[curr];
    if(l != r) {
        lazy[curr * 2] = lazy[curr];
        lazy[curr * 2 + 1] = lazy[curr];
    }
    lazy[curr] = -1;
}

void upd(int curr, int l, int r, int ql, int qr, int val) {
    push(curr, l, r);
    if(ql <= l && r <= qr) {
        lazy[curr] = val;
        push(curr, l, r);
        return;
    } else if(ql > r || qr < l) {return;}
    int m = (l + r) / 2ll;
    upd(curr * 2, l, m, ql, qr, val);
    upd(curr * 2 + 1, m + 1, r, ql, qr, val);
    tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
}

int get(int curr, int l, int r, int ql, int qr) {
    push(curr, l, r);
    if(ql <= l && r <= qr) {
        return tree[curr];
    } else if(ql > r || qr < l) {return 0;}
    int m = (l + r) / 2ll;
    return get(curr * 2, l, m, ql, qr) + get(curr * 2 + 1, m + 1, r, ql, qr);
}

ll findInv() {///BAD
    ll cnt = 0;
    upd(1, 0, MAX_N - 1, 0, MAX_N - 1, 0);
    for(int i = 0; i < n; i ++) {
        cnt += get(1, 0, MAX_N - 1, arr[i] + 1, MAX_N - 1);
        upd(1, 0, MAX_N - 1, arr[i], arr[i], 1);
    }
    return cnt;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    fill_n(lazy, 4 * MAX_N, -1);
    cin >> n;
    for(ll i = 0; i < n; i ++) {
        cin >> arr[i];
    }
    ll ans, inv = findInv();
    ans = inv;
    for(int i = 0; i < n; i ++) {
        upd(1, 0, MAX_N - 1, 0, MAX_N - 1, 0);
        upd(1, 0, MAX_N - 1, arr[i], arr[i], 1);
        for(int j = i + 1; j < n; j ++) {
            if(arr[i] < arr[j]) {continue;}
            ll nowAns = inv + 1;
            for(int k = i; k <= j; k ++) {
                if(arr[j] <= arr[k] && arr[k] <= arr[i]) {
                    nowAns --;
                }
            }
            chkmin(ans, nowAns);
            continue;
            upd(1, 0, MAX_N - 1, arr[j], arr[j], 1);
            cout << i << " " << j << " " << get(1, 0, MAX_N - 1, arr[j], arr[i]) << endl;
            chkmin(ans, inv - get(1, 0, MAX_N - 1, arr[j], arr[i]) + 1);
        }
    }
    cout << ans << endl;
}


