#include <bits/stdc++.h>
using namespace std;
//#pragma GCC target("sse4")
//#pragma GCC optimize("Ofast")
#define endl "\n"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) {out << x.first << " " << x.second; return out;}
template<class T, class T2> inline istream &operator >>(istream & in, pair<T, T2> &x) {in >> x.first >> x.second; return in;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}

const int MAX_N = 3e5 + 10;
int arr[MAX_N];
vector<int> tree[4 * MAX_N];

void build(int curr, int l, int r) {
    if(l == r) {
        tree[curr].push_back(arr[l]);
        return;
    }
    int m = (l + r) / 2ll;
    build(curr * 2, l, m);
    build(curr * 2 + 1, m + 1, r);
    merge(tree[curr * 2].begin(), tree[curr * 2].end(), tree[curr * 2 + 1].begin(), tree[curr * 2 + 1].end(), back_inserter(tree[curr]));
}

int query(int curr, int l, int r, int ql, int qr, int vall, int valr) {
    if(vall > valr) {return 0;}
    if(ql <= l && r <= qr) {
        return upper_bound(tree[curr].begin(), tree[curr].end(), valr) - lower_bound(tree[curr].begin(), tree[curr].end(), vall);
    } else if(l > qr || r < ql) {return 0;}
    int m = (l + r) / 2ll;
    return query(curr * 2, l, m, ql, qr, vall, valr) + query(curr * 2 + 1, m + 1, r, ql, qr, vall, valr);
}

vector<int> locMn, locMx;
int n;

namespace old {
    ll tree[4 * MAX_N], lazy[4 * MAX_N];
    void push(int curr, int l, int r) {
        if(lazy[curr] == -1) {return;}
        tree[curr] = (r - l + 1) * lazy[curr];
        if(l != r) {
            lazy[curr * 2] = lazy[curr];
            lazy[curr * 2 + 1] = lazy[curr];
        }
        lazy[curr] = -1;
    }
    void upd(int curr, int l, int r, int ql, int qr, int val) {
        push(curr, l, r);
        if(ql <= l && r <= qr) {
            lazy[curr] = val;
            push(curr, l, r);
            return;
        } else if(ql > r || qr < l) {return;}
        int m = (l + r) / 2ll;
        upd(curr * 2, l, m, ql, qr, val);
        upd(curr * 2 + 1, m + 1, r, ql, qr, val);
        tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
    }
    ll get(int curr, int l, int r, int ql, int qr) {
        if(r < l) {return 0;}
        push(curr, l, r);
        if(ql <= l && r <= qr) {
            return tree[curr];
        } else if(ql > r || qr < l) {return 0;}
        int m = (l + r) / 2ll;
        return get(curr * 2, l, m, ql, qr) + get(curr * 2 + 1, m + 1, r, ql, qr);
    }
    ll findInv() {///BAD
        ll cnt = 0;
        upd(1, 0, MAX_N - 1, 0, MAX_N - 1, 0);
        for(int i = 0; i < n; i ++) {
            cnt += get(1, 0, MAX_N - 1, arr[i] + 1, MAX_N - 1);
            upd(1, 0, MAX_N - 1, arr[i], arr[i], 1);
        }
        return cnt;
    }

};

signed main() {
    cin >> n;
    for(int i = 0; i < n; i ++) {
        cin >> arr[i];
    }
    build(1, 0, n - 1);
    int mx = 0;
    locMx.push_back(mx);
    for(int i = 1; i < n; i ++) {
        if(arr[i] > arr[mx]) {
            mx = i;
            locMx.push_back(mx);
        }
    }
    int mn = n - 1;
    locMn.push_back(mn);
    for(int i = n - 2; i >= 0; i --) {
        if(arr[i] < arr[mn]) {
            mn = i;
            locMn.push_back(mn);
        }
    }
    int inv = old::findInv(), ans = inv;
    for(auto it : locMx) {
        for(auto itt : locMn) {
            if(it >= itt) {continue;}
            chkmin(ans, inv - 2ll * (ll)query(1, 0, n - 1, it, itt, arr[itt] + 1, arr[it] - 1));
        }
    }
    cout << ans << endl;
}


