#include <iostream>

using namespace std;

const int MAXN = 1e6 + 5;
const long long inf = 1e15 + 5;

int n;
int p[MAXN];
int numPos[MAXN];

long long eval()
{
    long long ans = 0;
    for(int i = n;i>=1;i--)
    {
        int pos = numPos[i];
        for(int j = i+1;j<=n;j++)
            if(numPos[j]<numPos[i]) pos--;

        ans += i - 1 - pos;
    }

    return ans;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for(int i = 0;i<n;i++) cin >> p[i];

    for(int i = 0;i<n;i++)
        numPos[p[i]] = i;

    long long ans = inf;
    for(int i = 0;i<n;i++)
    {
        for(int j = i+1;j<n;j++)
        {
            swap(numPos[p[i]], numPos[p[j]]);
            ans = min(ans, 1 + eval());
            swap(numPos[p[i]], numPos[p[j]]);
        }
    }

    cout << ans << '\n';
}
