#include <iostream>
#include <vector>
#include <utility>
using namespace std;

const int MOD = 1000000007;

int n, m, b;
int c[20];

long long dp[20][4];

vector<pair<char, int>> rules[20];

void Init()
{
    cin >> n >> m >> b;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> c[i];
    }
    for (int i = 1; i <= m; ++ i)
    {
        int p, q, k;
        char sign;
        cin >> p >> sign >> q >> k;
        rules[n - p].emplace_back(sign, k);
    }
}

int main()
{
    Init();

    for (int i = 1; i <= n; ++ i)
    {
        int sum1 = c[i];
        int sum2 = c[i] - 1;
        int sum3 = c[i] + b;
        int sum4 = c[i] + b - 1;

        for (int p = 0; p < b; ++ p)
        {
            for (int q = 0; q < b; ++ q)
            {
                bool fl = true;
                for (int k = 0; k < rules[i].size(); ++ k)
                {
                    if (rules[i][k].first == '+' and p + q != rules[i][k].second) {fl = false; break;}
                    if (rules[i][k].first == '-' and p - q != rules[i][k].second) {fl = false; break;}
                }

                if (!fl) continue;
                if (i == 1 and (p == 0 or q == 0)) continue;

                int sum = p + q;
                if (sum == sum1) dp[i][0]++;
                if (sum == sum2) dp[i][1]++;
                if (i != 1 and sum == sum3) dp[i][2]++;
                if (i != 1 and sum == sum4) dp[i][3]++;
            }
        }

        {
            if (i != 1) dp[i][0] *= dp[i - 1][0] + dp[i - 1][2];
            dp[i][0] %= MOD;
        }
        {
            if (i != 1) dp[i][1] *= dp[i - 1][0] + dp[i - 1][2];
            dp[i][1] %= MOD;
        }
        if (i != 1)
        {
            dp[i][2] *= dp[i - 1][1] + dp[i - 1][3];
            dp[i][2] %= MOD;
        }
        if (i != 1)
        {
            dp[i][3] *= dp[i - 1][1] + dp[i - 1][3];
            dp[i][3] %= MOD;
        }

        // cout << dp[i][0] << ' ' << dp[i][1] << ' ' << dp[i][2] << ' ' << dp[i][3] << endl;
    }

    cout << (dp[n][0] + dp[n][2]) % MOD << endl;
    return 0;
}
