#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

int t, n, k;
int r[3];
int coords[2048576];

struct mag
{
    int last[3];
};

bool ans;
vector<mag> v[2048576][3];

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> t;
    for(int z = 0; z < t; z++){
        ans = true;
        cin >> n >> k;
        for(int i = 0; i < k; i++){
            cin >> r[i];
        }
        sort(r, r+k);
        for(int i = 0; i < n; i++){
            cin >> coords[i];
        }

        v[0][0].push_back({0, -1, -1});
        v[0][1].push_back({-1, 0, -1});
        v[0][2].push_back({-1, -1, 0});

        for(int i = 1; i < n; i++){
            for(int j = 0; j < k; j++){
                if(coords[i] - coords[i-1] >= r[j]){
                    for(int a = 0; a < v[i-1][j].size(); a++){
                        v[i][j].push_back(v[i-1][j][a]);
                        v[i][j][a].last[j] = i;
                    }
                }
            }
            if(v[i][0].empty() && v[i][1].empty() && v[i][2].empty()){
                ans = false;
                break;
            }
        }

        cout << ans << endl;
        for(int i = 0; i < n; i++){
            v[i][0].clear();
            v[i][1].clear();
            v[i][2].clear();
        }
    }

return 0;
}

