#include <iostream>
#include <string.h>
using namespace std;
#define endl '\n'
const int MAXN=2e6+10;
const int MAXM=8e2+10;
int a[MAXN], dist[4], dp[MAXM][MAXM][8], d[MAXN][4];
bool cur[4];
void precomp(int n) {
    int br1, br2;
    for (int i=0;i<3;i++) {
        br1=br2=0;
        while (br1<n) {
            if (br2==n) {
                d[br1][i]=n;
                br1++;
                continue;
            }
            if (a[br1]+dist[i]>a[br2]) br2++;
            else {
                d[br1][i]=br2;
                br1++;
            }
        }
    }
}
int make_mask(int a, int b, int c) {
    int ans=0;
    if (a>0) ans+=1;
    if (b>0) ans+=2;
    if (c>0) ans+=4;
    return ans;
}
bool f(int l, int r, int mask) {
    if (mask==0) return false;
    if (l>=r) return true;
    if (dp[l][r][mask]!=-1) return dp[l][r][mask];
    dp[l][r][mask]=0;
    int br=0, kopie=mask;
    while (mask>0) {
        cur[br]=mask%2;
        br++;
        mask/=2;
    }
    int next;
    if (cur[0]) {
        mask=make_mask(0,cur[1],cur[2]);
        next=min(d[l][0],r);
        if (f(l+1,next-1,mask) && f(next,r,kopie)) dp[l][r][kopie]=1;
    }
    if (dp[l][r][kopie]==1) return true;
    if (cur[1]) {
        mask=make_mask(cur[0],0,cur[2]);
        next=min(d[l][1],r);
        if (f(l+1,next-1,mask) && f(next,r,kopie)) dp[l][r][kopie]=1;
    }
    if (dp[l][r][kopie]==1) return true;
    if (cur[2]) {
        mask=make_mask(cur[0],cur[1],0);
        next=min(d[l][2],r);
        if (f(l+1,next-1,mask) && f(next,r,kopie)) dp[l][r][kopie]=1;
    }
    if (dp[l][r][kopie]==1) return true;
    return dp[l][r][kopie]=0;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k, t;
    cin >> t;
    for (int test=0;test<t;test++) {
        cin >> n >> k;
        if (k==1) {
            cin >> dist[0];
            for (int i=0;i<n;i++) cin >> a[i];
            bool fl=true;
            for (int i=0;i<n;i++) {
                if (a[i]-dist[0]<a[i-1]) {
                    fl=false;
                    break;
                }
            }
            cout << fl << endl;
        } else {
            for (int i=0;i<k;i++) cin >> dist[i];
            for (int i=0;i<n;i++) cin >> a[i];
            if (k==3 && dist[0]==dist[1] && dist[1]==dist[2]) {
                bool fl=true;
                for (int i=2;i<n;i++) {
                    if (a[i]-dist[0]<a[i-3]) {
                        fl=false;
                        break;
                    }
                }
                cout << fl << endl;
                continue;
            }
            precomp(n);
            memset(dp,-1,sizeof(dp));
            int cur_mask;
            if (k==2) cur_mask=3;
            else cur_mask=7;
            cout << f(0,n-1,cur_mask) << endl;
        }
    }
    return 0;
}
/**
1
7 3
8 5 10
1 2 4 9 11 14 15
**/
