#include <iostream>
#include <vector>
#include <string.h>
using namespace std;
const int MAXN=1e5+10;
const long long mod=1e9+7;
struct node {
    int y, zn, sum;
};
vector <node> v[MAXN];
vector <int> comp;
bool used[MAXN], used_cur[MAXN];
long long f[MAXN];
int n, m, b;
void dfs_comp(int x) {
    used[x]=true;
    comp.push_back(x);
    for (auto i:v[x]) {
        if (used[i.y]) continue;
        dfs_comp(i.y);
    }
}
void dfs_find(int x, int j) {
    f[x]=j;
    used_cur[x]=true;
    int num;
    for (auto i:v[x]) {
        if (used_cur[i.y]) continue;
        if (i.zn==1) num=i.sum-j;
        else num=j-i.sum;
        dfs_find(i.y,num);
    }
}
bool check() {
    for (auto x:comp) {
        if ((x==n-1 || x==2*n-1) && f[x]==0) return false;
        if (f[x]<0 || f[x]>=b) return false;
        for (auto i:v[x]) {
            if (i.zn==1 && f[x]+f[i.y]!=i.sum) return false;
            if (i.zn==-1 && f[x]-f[i.y]!=i.sum) return false;
        }
    }
    return true;
}
int main () {
    int c;
    cin >> n >> m >> b;
    for (int i=n-1;i>=0;i--) {
        cin >> c;
        v[i].push_back({i+n,1,c});
        v[i+n].push_back({i,1,c});
    }
    long long ans=1;
    int ind, ind1, raz;
    char z;
    for (int i=0;i<m;i++) {
        cin >> ind >> z >> ind1 >> raz;
        if (z=='+') {
            v[ind].push_back({ind1+n,1,raz});
            v[ind1+n].push_back({ind,1,raz});
        } else {
            v[ind].push_back({ind1+n,-1,raz});
            v[ind1+n].push_back({ind,-1,-raz});
        }
    }
    for (int i=0;i<2*n;i++) {
        if (!used[i]) {
            if (!comp.empty()) comp.clear();
            dfs_comp(i);
            long long s=0;
            int start=0;
            if (i==n-1 || i==2*n-1) start=1;
            for (int j=start;j<b;j++) {
                memset(used_cur,false,sizeof(used_cur));
                dfs_find(i,j);
                if (check()) s++;
            }
            ///cout << s << endl;
            ans=(ans*s)%mod;
        }
    }
    cout << ans << endl;
    return 0;
}
/**
3 1 10
9 9 9
0 - 1 2
**/

